package com.ccnode.codegenerator.mybatisGenerator.plugins;

package .tmp;

import com.ccnode.codegenerator.mybatisGenerator.plugins.tools.FormatTools;
import com.ccnode.codegenerator.mybatisGenerator.plugins.tools.JavaElementGeneratorTools;
import com.ccnode.codegenerator.mybatisGenerator.plugins.tools.XmlElementGeneratorTools;
import java.util.List;
import java.util.Properties;
import org.mybatis.generator.api.IntrospectedTable;
import org.mybatis.generator.api.PluginAdapter;
import org.mybatis.generator.api.dom.java.FullyQualifiedJavaType;
import org.mybatis.generator.api.dom.java.Interface;
import org.mybatis.generator.api.dom.java.JavaVisibility;
import org.mybatis.generator.api.dom.java.Method;
import org.mybatis.generator.api.dom.java.Parameter;
import org.mybatis.generator.api.dom.java.TopLevelClass;
import org.mybatis.generator.api.dom.xml.Attribute;
import org.mybatis.generator.api.dom.xml.Document;
import org.mybatis.generator.api.dom.xml.Element;
import org.mybatis.generator.api.dom.xml.TextElement;
import org.mybatis.generator.api.dom.xml.XmlElement;
import org.mybatis.generator.codegen.mybatis3.ListUtilities;
import org.mybatis.generator.internal.util.StringUtility;

public class UpsertPlugin extends PluginAdapter {
  public String a;
  
  public static final String b = "insertOrUpdateWithBLOBs";
  
  public String c;
  
  public static final String d = "useMybatisPlus3";
  
  public static final String e = "useOldName";
  
  public boolean a;
  
  public UpsertPlugin() {
    this.a = "insertOrUpdate";
    this.c = "insertOrUpdateSelective";
    this.a = false;
  }
  
  public boolean validate(List<String> paramList) {
    return true;
  }
  
  public boolean clientGenerated(Interface paramInterface, TopLevelClass paramTopLevelClass, IntrospectedTable paramIntrospectedTable) {
    Method method1 = JavaElementGeneratorTools.a(this.a, JavaVisibility.DEFAULT, 

        
        FullyQualifiedJavaType.getIntInstance(), new Parameter[] { new Parameter(
            JavaElementGeneratorTools.a(paramIntrospectedTable), "record") });
    FormatTools.a(paramInterface, method1);
    if (paramIntrospectedTable.hasBLOBColumns()) {
      Method method = JavaElementGeneratorTools.a("insertOrUpdateWithBLOBs", JavaVisibility.DEFAULT, 

          
          FullyQualifiedJavaType.getIntInstance(), new Parameter[] { new Parameter(
              JavaElementGeneratorTools.b(paramIntrospectedTable), "record") });
      FormatTools.a(paramInterface, method);
    } 
    FullyQualifiedJavaType fullyQualifiedJavaType = paramIntrospectedTable.getRules().calculateAllFieldsClass();
    Method method2 = JavaElementGeneratorTools.a(this.c, JavaVisibility.DEFAULT, 

        
        FullyQualifiedJavaType.getIntInstance(), new Parameter[] { new Parameter(fullyQualifiedJavaType, "record") });
    FormatTools.a(paramInterface, method2);
    return super.clientGenerated(paramInterface, paramTopLevelClass, paramIntrospectedTable);
  }
  
  public boolean sqlMapDocumentGenerated(Document paramDocument, IntrospectedTable paramIntrospectedTable) {
    a(paramDocument, paramIntrospectedTable, false);
    if (paramIntrospectedTable.hasBLOBColumns())
      a(paramDocument, paramIntrospectedTable, true); 
    a(paramDocument, paramIntrospectedTable);
    return super.sqlMapDocumentGenerated(paramDocument, paramIntrospectedTable);
  }
  
  private void a(Document paramDocument, IntrospectedTable paramIntrospectedTable) {
    List list = ListUtilities.removeGeneratedAlwaysColumns(paramIntrospectedTable.getAllColumns());
    XmlElement xmlElement1 = new XmlElement("insert");
    xmlElement1.addAttribute(new Attribute("id", this.c));
    getContext().getCommentGenerator().addComment(xmlElement1);
    xmlElement1.addAttribute(new Attribute("parameterType", paramIntrospectedTable.getRules().calculateAllFieldsClass().getFullyQualifiedName()));
    XmlElementGeneratorTools.a(xmlElement1, paramIntrospectedTable);
    xmlElement1.addElement((Element)new TextElement("insert into " + paramIntrospectedTable.getFullyQualifiedTableNameAtRuntime()));
    XmlElement xmlElement2 = XmlElementGeneratorTools.a(list);
    xmlElement1.addElement((Element)xmlElement2);
    xmlElement1.addElement((Element)new TextElement("values"));
    XmlElement xmlElement3 = XmlElementGeneratorTools.b(list);
    xmlElement1.addElement((Element)xmlElement3);
    xmlElement1.addElement((Element)new TextElement("on duplicate key update "));
    XmlElement xmlElement4 = XmlElementGeneratorTools.c(list);
    xmlElement1.addElement((Element)xmlElement4);
    paramDocument.getRootElement().addElement((Element)xmlElement1);
  }
  
  private void a(Document paramDocument, IntrospectedTable paramIntrospectedTable, boolean paramBoolean) {
    List list = ListUtilities.removeGeneratedAlwaysColumns(paramBoolean ? paramIntrospectedTable.getAllColumns() : paramIntrospectedTable.getNonBLOBColumns());
    XmlElement xmlElement = new XmlElement("insert");
    xmlElement.addAttribute(new Attribute("id", paramBoolean ? "insertOrUpdateWithBLOBs" : this.a));
    getContext().getCommentGenerator().addComment(xmlElement);
    xmlElement.addAttribute(new Attribute("parameterType", 
          paramBoolean ? JavaElementGeneratorTools.b(paramIntrospectedTable).getFullyQualifiedName() : JavaElementGeneratorTools.a(paramIntrospectedTable).getFullyQualifiedName()));
    XmlElementGeneratorTools.a(xmlElement, paramIntrospectedTable);
    xmlElement.addElement((Element)new TextElement("insert into " + paramIntrospectedTable.getFullyQualifiedTableNameAtRuntime()));
    for (Element element : XmlElementGeneratorTools.c(list, null))
      xmlElement.addElement(element); 
    xmlElement.addElement((Element)new TextElement("values"));
    for (Element element : XmlElementGeneratorTools.b(list, null, true))
      xmlElement.addElement(element); 
    xmlElement.addElement((Element)new TextElement("on duplicate key update "));
    for (Element element : XmlElementGeneratorTools.d(list, null))
      xmlElement.addElement(element); 
    paramDocument.getRootElement().addElement((Element)xmlElement);
  }
  
  private void a(IntrospectedTable paramIntrospectedTable, XmlElement paramXmlElement, List<Element> paramList) {
    paramXmlElement.addElement((Element)new TextElement("select"));
    for (Element element : paramList)
      paramXmlElement.addElement(element); 
    paramXmlElement.addElement((Element)new TextElement("from dual where not exists"));
    paramXmlElement.addElement((Element)new TextElement("("));
    paramXmlElement.addElement((Element)new TextElement("select 1 from " + paramIntrospectedTable.getFullyQualifiedTableNameAtRuntime()));
    paramXmlElement.addElement(XmlElementGeneratorTools.d(paramIntrospectedTable));
    paramXmlElement.addElement((Element)new TextElement(")"));
  }
  
  public void setProperties(Properties paramProperties) {
    super.setProperties(paramProperties);
    String str = paramProperties.getProperty("useMybatisPlus3");
    if (StringUtility.isTrue(str)) {
      String str1 = paramProperties.getProperty("useOldName");
      if (!StringUtility.isTrue(str1)) {
        this.a = true;
        this.a = "insertOnDuplicateUpdate";
        this.c = "insertOnDuplicateUpdateSelective";
      } 
    } 
  }
}
